c
c *****************************************************************
c
      SUBROUTINE MENU(N,TITLE,PROMPT,IOPTION,IERR)
c
c Revision : 1.1, Feb. 22, 1990, Broome
c
c Purpose : General purpose menu routine for FORTRAN programs
c
      character*72 prompt(10),title
c
$include:'menu.cmn'
c
      if(n.gt.10) then
        call error('MENU: number of prompts exceeds limit of 10')
        ierr = 1
        return
      endif
c
c Clear graphics and home cursor
c
100   write(*,1111) sgr0
      write(*,1111) ed
      write(*,1111) sgr7
c
c Print title
c
      write(*,1111) sgr1
      write(*,*) title
      write(*,1111) sgr0
c
      write(*,*)' '
c
c Print menu options
c
      do 200 j=1, n
        write(*,1010) j,prompt(j)
1010    format('     ',i2,') ',A72)
200   continue
c
c Prompt user for selection
c
220   write(*,1111) sgr1
      write(*,'(/a\)') ' Select option by number : '
      write(*,1111) sgr0
      read(*,*,err=400) ioption
      if(ioption.gt.n.or.ioption.le.0) then
        write(*,*) 'Select an option between 1 and ',n
        go to 220
      endif
      go to 999
c
400   write(*,*)' '
      write(*,*)' Input error, retry'
      call hret
      go to 100
c
999   return
      end
c
c *****************************************************************
      SUBROUTINE ERROR (STRING)
c
c Purpose : To display bold, blinking error messages on the screen
c
      character  string*(*)
c

$include:'menu.cmn'
c
      write(*,1111) sgr1,sgr5
      write(*,*) ' '
      write(*,'(a\)') ' ERROR :'
      write(*,1111) sgr0, sgr1
      write(*,*) string
      write(*,1111) sgr0
      return
      end
c
c ************************************************************
      SUBROUTINE LCVAR(L,STRING)
c
c Purpose: To return the position of the first blank
c       character in a string.
c
c Arguments : l - position of the first blank character
c                  (integer*4)
c        string - character string to search
c
      character string*80,charl
c
      do 10 j=1 , 80
        l = j
        charl = string(l:l)
        if(charl.eq.' ') return
10    continue
c
      return 
      end
