c
c MAGRAV2 (V. 2.1) SUBROUTINE BLOCK : MS2 (Halo Professional)
c Edited last : Sept. 24, 1992;   J. Broome
c (NEC-MGE version)
c
$nofloatcalls
c**********************************************************************
      SUBROUTINE WHAT (IWHAT)
c
c purpose : To interpret text mode commands and return a 
c        value in "iwhat" that tells the program what to do
c
c parameters : iwhat - "1-39" for legitimate commands
c                      "0" for unrecognized commands
c                      "-1" for null response
c
      character ians*4, lckomms(39)*4, uckomms(39)*4
$include:'magrav.cmn'      
c
      data lckomms/'eobs','ebod','mpoi','epar','cont','draw','sket',
     +    'read','writ','anom','tano','tobs','ecom',
     +    'tcom','prnt','inse','dpoi','end','tabl',
     +    'reco','dump','maut','tpar','magn','grav','menu',
     +    'zoom','msca','>>>>','tbod','tsca','offs','diff','help',
     +    'mbod','dbod','asca','conf','save'/
c
      data uckomms/'EOBS','EBOD','MPOI','EPAR','CONT','DRAW','SKET',
     +    'READ','WRIT','ANOM','TANO','TOBS','ECOM',
     +    'TCOM','PRNT','INSE','DPOI','END','TABL',
     +    'RECO','DUMP','MAUT','TPAR','MAGN','GRAV','MENU',
     +    'ZOOM','MSCA','>>>>','TBOD','TSCA','OFFS','DIFF','HELP',
     +    'MBOD','DBOD','ASCA','CONF','SAVE'/
c
      data nkomms/40/
c
      read(*,150,err=200) ians
150   format(a4)
      if(ians.eq.' ') then
        iwhat = -1
        return
      endif
      do 170 iwhat = 1, nkomms
        if(lckomms(iwhat).eq.ians) return
        if(uckomms(iwhat).eq.ians) return
170   continue
200   iwhat = 0
      return
      end
c
*********************************************************************
      SUBROUTINE POIN
c
c purpose : To allow body point positions to be changed in text mode
c
c
$include:'magrav.cmn'    
c
100   write(*,1111) ed
      write(*,'(/a)')' Enter the body number for the point'
      write(*,'(a\)')'  to be moved : '
      read(*,*,err=400) ibod
      if(ibod.gt.nbods.or.ibod.le.0)  then
        call error(' This body number is not defined')
        goto 100
      endif
      call typbod(ibod)
200   write(*,'(a\)')' Enter no. of point to be changed : '
      read(*,*,err=400) npt
      if(npt.ge.npts(ibod).or.npt.le.0) then
        call error(' This point number is not defined in this body')
        go to 200
      endif
      write(*,1000) npt,x(npt,ibod),z(npt,ibod)
1000  format(1h ,'Point ',i3,',X and Z (km) : ',2f10.2)
      write(*,'(a\)')' Enter new X and Z position (km) : '
      read(*,*,err=400) x(npt,ibod),z(npt,ibod)
      if(z(npt,ibod).lt.0) then
        call error(' Z cannot be less than 0, Z set to 0')
        z(npt,ibod) = 0
      endif
      ianom(ibod) = 0
      kalk = 1
c
      if(npt.eq.1) then
c    If first point changes change last point
        npt = npts(ibod)
        x(npt,ibod) = x(1,ibod)
        z(npt,ibod) = z(1,ibod)
      endif
      if(igrap.ne.0) then
        call plbod(ibod,nclr)
      endif
c
c Check for duplicate consecutive points
c
      call remdup (ibod)
c
      return
c
400   call error(' Input error! ')
      return
      end
c
********************************************************************
      SUBROUTINE INSE
c
c purpose : To allow points to be inserted into bodies in text
c              mode
c
$include:'magrav.cmn'
c
100   write(*,1111) ed
      write(*,'(/a\)')' Enter body no. for inserted point : '
      read(*,*,err=400) ibod
        if(ibod.lt.1.or.ibod.gt.nbods) then
        call error(' This body number is not defined')
        return
      endif
      call typbod(ibod)
200   write(*,*)'Enter the number of the old point after which'
      write(*,'(a\)')' the new point is to be inserted : '
      read(*,*,err=400) npt
      if(npt.lt.npts(ibod)) then
          write(*,'(a\)')' Enter X and Z coordinates(km) : '
          read(*,*,err=400) xxx,zz
          call insert(xxx,zz,ibod,npt,iret)
          if(iret.ne.-1) then
            call error('Unable to insert point in body')
          else
            write(*,*)'Point inserted in body',ibod
          endif
          call remdup (ibod)  
        return
      else
        call error('Old point number exceeds number in body')
        go to 200
      endif
400   call error(' Input error')
      go to 100
      return
      end
c
***********************************************************************
      SUBROUTINE DELE
c
c purpose : To delete a point from a body in text mode
c
$include:'magrav.cmn'
c
100   write(*,1111) ed
      write(*,'(/a\)')' Enter body number for point deletion : '
      read(*,*,err=400) ibod
      if(ibod.gt.nbods.or.ibod.lt.1) then
        call error(' This body number is not defined')
        return
      endif
      call typbod(ibod)
200   write(*,'(a\)')' Enter number of point to be deleted : '
      read(*,*,err=400) npt
      if(npt.lt.1.or.npt.ge.npts(ibod)) then
        call error(' This point not defined in this body')
        return
      endif
      xxx = x(npt,ibod)
      zz = z(npt,ibod)
      call delete(ibod,npt,iret)
      if(iret.eq.-1) then
        write(*,*)'point ',npt,' deleted'
        call remdup (ibod)
      else
        call bold('WARNING!, point not deleted')
      endif
      return
c
400   call error ('Input error')
      return
      end
c
***********************************************************************
      SUBROUTINE RECO
c
c purpose : To read the common block into the program to recover
c             to the previous step.
c
$include:'magrav.cmn'
c
      if(nback.eq.0) then
        call error('Recovery impossible,nothing in recovery file')
        return
      endif
c
      nrec = 1
      if(nrec.ge.nback) then
        nrec = nback + nsav - nrec
        nback = nrec
      else
        nback = nback - nrec
      endif
      if(irecov(nback).eq.0) then
        call error(' Recovery impossible,nothing in recovery file')
        return
      endif
      itypeo = itype
      read(lunscr,rec=nback,err=300,iostat=kerr) itype,
     +  bdip,nfield,anomax,anomin,
     +  kommnt,zmax,space,xlen,kalk,xoffs,
     +  xton,dec,dip,zcon,x,z,npts,
     +  rmmin,rhomag,rmmax,bdec,bdy,
     +  obs,ianom,skxmin,skxmax,skzmin,skzmax,
     +  offset,nbods,difmin,difmax,xdis,zdis,
     +  calc,xpos,mode
      if(itype.ne.itypeo) then
        if(itype.eq.1)then
          write(*,'(/a)')'  Modelling mode now GRAVITY.'
        else
          write(*,'(/a)')'  Modelling mode now MAGNETICS.'
        endif
      endif
      mode = 1
      xlpl = xpos(1,itype)
      xupl = xpos(nfield(itype),itype)
      zlpl = zmax
      zupl = 0.0
      write(*, *) 'Model recovered'
      return
300   write(*,1111) sgr1
      write(*,*)'WARNING!,model not recovered,iostat= ',kerr
      write(*,1111) sgr0
      return

400   call error ('Input ERROR')
      return
      end
c
c ***************************************************************
      SUBROUTINE SAV
c
c purpose : To save the current model in case of system crash
c           or user error
c
$include:'magrav.cmn'
c
      if(nsav.eq.0) return
      if(nback.eq.0) then
        do 10 k = 1 , nsav
10      irecov(k) = 0
      endif
      nback= nback+1
      if(nback.gt.nsav) nback = nback - nsav
      write(lunscr,rec=nback,err=100,iostat=ierr) itype,
     +  bdip,nfield,anomax,anomin,
     +  kommnt,zmax,space,xlen,kalk,xoffs,
     +  xton,dec,dip,zcon,x,z,npts,
     +  rmmin,rhomag,rmmax,bdec,bdy,
     +  obs,ianom,skxmin,skxmax,skzmin,skzmax,
     +  offset,nbods,difmin,difmax,xdis,zdis,
     +  calc,xpos,mode
      irecov(nback) = 1
      return
c
100   call error ('SAV:Error writing to recovery file')
      write(*,*) 'iostat= ',ierr
      call hret
      return
      end
c
c ***********************************************************
      SUBROUTINE TYPOBS
c
c Purpose : To print out the observed data
c
$include:'magrav.cmn'
c
      write(*,1111) ed
      if(itype.eq.1) then
        write(*,'(/a/)')' GRAVITY observations'
      else
        write(*,'(/a/)')' MAGNETIC observations'
      endif
      write(*,1000) offset(itype)
1000  format(' Value added to data for plotting = ',f7.2,/,
     + ' "-9999.0" values are undefined')

      write(*,'(/a/)')' Point, Position(km), Data value : '
      nf = nfield(itype)
      do 200 i = 1, nf
        write(*,1010) i,xpos(i,itype),obs(itype,i)
1010    format(i4,2x,f10.2,2x,f10.2)
200   continue
      return
      end
c
c **************************************************************
      SUBROUTINE ASCALE
c
c Purpose : to automatically scale anomaly data to fill the
c           screen.
c
$include:'magrav.cmn'
c
      anmin = 999999.9
      anmax = -999999.9
      do 10 ipt = ostart(itype), oend(itype)
        obsoff = obs(itype,ipt) + offset(itype)
        anmin = amin1(anmin,obsoff)
        anmin = amin1(anmin,calc(maxcal,ipt))
        anmax = amax1(anmax,obsoff)
        anmax = amax1(anmax,calc(maxcal,ipt))
10    continue
      danom = (anmax-anmin)*0.10
      anomax(itype) = anmax + danom
      anomin(itype) = anmin - danom
      write(*,1000) anomin(itype),anomax(itype)
1000  format(1h 'Anomaly plot scale minimum and maximum :',
     +2f10.2)
c
      return
      end
c
c *************************************************************
      SUBROUTINE HELP(IWHAT)
c
c purpose : To print out descriptive text about each text mode
c           option
c
c parameters : iwhat - input parameter indicating which option
c
$include:'magrav.cmn'
c
      write(*,1111) ed
      if(iwhat.lt.1.or.iwhat.gt.39) return
      goto(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
     +     21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,
     +     38,39) iwhat
c
1     write(*,*)'EOBS    (Enter OBServed)'
      write(*,*)'    This option allows you to enter the measured'
      write(*,*)'   gravity or magnetic data. Values can be entered'
      write(*,*)'   manually from the keyboard or from a "profile"'
      write(*,*)'   file.'
      return
2     write(*,*)'EBOD     (Enter BODy)'
      write(*,*)'    This option allows you to enter source body'
      write(*,*)'   points. A maximum of',maxbod,' bodies with '
      write(*,*)'   ',maxnpt,' points are possible. Body numbers'
      write(*,*)'   are selected automatically and EPAR is used to '
      write(*,*)'   enter magnetic or gravity characteristics.'
      write(*,*)'   Points must be entered in clockwise order !'
      return
3     write(*,*)'MPOI     (Move POInt)'
      write(*,*)'    The X and Z coordinates of body points can be'
      write(*,*)'   moved using this option. The point to be moved'
      write(*,*)'   is specified by body number and point number.'
      return
4     write(*,*)'EPAR     (Enter PARameters)'
      write(*,*)'    Body half strike extent,density, and magnetization'
      write(*,*)'    can be entered. For density and magnetization,'
      write(*,*)'    a minimum and maximum value specify the range '
      write(*,*)'    for automatic contrast setting with CONT.'
      write(*,*)'    Declination and dip are specified to allow'
      write(*,*)'    remanent magnetization to be accounted for. With'
      write(*,*)'    no remanent magnetization they are set the same'
      write(*,*)'    as the field values.'
      return
5     write(*,*)'CONT    (CONTrast)'
      write(*,*)'    This option automatically varies the density'
      write(*,*)'   or magnetization to improve the least squares'
      write(*,*)'   fit of the calculated anomaly to the measured one.'
      return
6     write(*,*)'DRAW    (DRAW)'
      write(*,*)'    In graphics mode, this option draws the full'
      write(*,*)'   length of both profiles and the bodies on the'
      write(*,*)'   graphics monitor.'
      return
7     write(*,*)'SKET    (SKETch)'
      write(*,*)'    In graphics mode, this option draws a subarea'
      write(*,*)'   of the body display defined using ZOOM.'
      return
8     write(*,*)'READ    (READ model)'
      write(*,*)'    This option reads a model from the ASCII model'
      write(*,*)'   file specified.'
      return
9     write(*,*)'WRIT    (WRITe model)'
      write(*,*)'    This option writes the current model to a'
      write(*,*)'   ASCII model file.'
      return
10    write(*,*)'ANOM    (ANOMaly)'
      write(*,*)'    Calculate the anomaly and plot it if you are'
      write(*,*)'   in graphics mode. If body=0 is selected the '
      write(*,*)'   total anomaly is plotted, otherwise a colour-'
      write(*,*)'   coded anomaly for the specified body is plotted.'
      return
11    write(*,*)'TANO    (Type ANOmaly)'
      write(*,*)'    Print out the combined anomaly on the text '
      write(*,*)'   monitor.'
      return
12    write(*,*)'TOBS    (Type OBServed)'
      write(*,*)'    Print out the observed magnetic or gravity data'
      write(*,*)'   on the text monitor.'
      return
13    write(*,*)'ECOM    (Enter COMments)'
      write(*,*)'    This option allows you to enter a 80 character'
      write(*,*)'   text string to describe the model. The string is'
      write(*,*)'   stored with the model on disc.'
      return
14    write(*,*)'TCOM    (Type COMmments)'
      write(*,*)'    This option prints out the text comment stored'
      write(*,*)'   with the model.'
      return
15    write(*,*)'PRNT    (PRiNT screen)'
      write(*,*)'     This option prints the current screen display'
      write(*,*)'    on the printer selected during program '
      write(*,*)'    configuration.'
      return
16    write(*,*)'INSE    (INSErt point)'
      write(*,*)'    This option allows you to insert a point in a '
      write(*,*)'   body after a specified point number.'
      return
17    write(*,*)'DPOI    (Delete POInt)'
      write(*,*)'    This option allows you to delete a specified point'
      write(*,*)'   in a specified body.'
      return
18    write(*,*)'END     (END program)'
      write(*,*)'    Type end to exit from the program. You must call'
      write(*,*)'   WRIT before END to save your new model or any'
      write(*,*)'   changes to your old model or they will be lost.'
      return
19    write(*,*)'TABL    (TABLet)'
      write(*,*)'    This option transfers program control to the'
      write(*,*)'   graphics tablet. Program options can then be '
      write(*,*)'   selected by placing the cursor over the desired'
      write(*,*)'   option and pressing the cursor button. Body'
      write(*,*)'   points can be identified and moved with cursor'
      write(*,*)'   as well. The small box in the lower left corner'
      write(*,*)'   indicates the cursor positioning tolerance'
      return
20    write(*,*)'RECO    (RECOver)'
      write(*,*)'    This option allows you to go back to previous '
      write(*,*)'   steps in the modelling procedure. Each call of '
      write(*,*)'   RECOver undoes one change. You may recover a'
      write(*,*)'   maximum of 20 changes.'
      return
21    write(*,*)'DUMP    (DUMP model to screen)'
      write(*,*)'    This option prints out all bodies,anomalies,'
      write(*,*)'   parameters and scaling information on the text'
      write(*,*)'   monitor'
      return
22    write(*,*)'MAUT    (Move point AUTomatically)'
      write(*,*)'    This option allows you to automatically move a'
      write(*,*)'   point to improve the least squares fit of the'
      write(*,*)'   calculated to the observed profile. The anomaly'
      write(*,*)'   for the body the point is in will be calculated'
      write(*,*)'   a number of times while moving the point to '
      write(*,*)'   calculate the best position. If the point position'
      write(*,*)'   is not well constrained, The result may not be '
      write(*,*)'   satisfactory due to roundoff errors.'
      return
23    write(*,*)'TPAR    (Type PARameters)'
      write(*,*)'    This option prints out all body density or'
      write(*,*)'   magnetization parameters on the text monitor.'
      return
24    write(*,*)'MAGN    (MAGNetics mode)'
      write(*,*)'    This option puts the program in a magnetic'
      write(*,*)'   modelling mode. The option of setting the magnetic'
      write(*,*)'   field parameters is offered.'
      return
25    write(*,*)'GRAV    (GRAVity mode)'
      write(*,*)'    This option puts the program in a gravity'
      write(*,*)'   modelling mode.'
      return
26    write(*,*)'MENU    (MENU)'
      write(*,*)'    This option prints out the possible options'
      write(*,*)'   on the text monitor.'
      return
27    write(*,*)'ZOOM    (ZOOM)'
      write(*,*)'    This option allows you to set the plotting'
      write(*,*)'   limits for the SKET mode.'
      return
28    write(*,*)'MSCA    (Manual SCAle)'
      write(*,*)'    This option allows you to manually set the '
      write(*,*)'   profile scale parameters,the crossection depth'
      write(*,*)'   and the SKET plotting limits.'
      return
29    return
30    write(*,*)'TBOD    (Type BODies)'
      write(*,*)'    This option types out parameters and point'
      write(*,*)'   positions for a selected body.'
      return
31    write(*,*)'TSCA    (Type SCAle)'
      write(*,*)'    This option prints out scaling parameters'
      write(*,*)'   on the text monitor.'
      return
32    write(*,*)'OFFS    (OFFSet)'
      write(*,*)'    Allows automatic or manual determination of the'
      write(*,*)'   offset added to the observed data for plotting'
      write(*,*)'    '
      write(*,*)'   Option 1 automatically calculates the optimum'
      write(*,*)'     least-squares offset for the observed data.'
      write(*,*)'     plotting.'
      write(*,*)'   Option 2 allows the user to specify the point on'
      write(*,*)'     the profile where the observed and calculated '
      write(*,*)'     profiles should be plotted superimposed.'
      return
33    write(*,*)'DIFF    (DIFFerence plot)'
      write(*,*)'    This option switches a automatically scaled plot'
      write(*,*)'   of the difference betweem the observed and '
      write(*,*)'   calculated anomalies on and off.'
      return
34    write(*,*)'HELP    (HELP)'
      write(*,*)'    This option gives a brief description of each'
      write(*,*)'   option. You are in HELP now.'
      return
35    write(*,*)'MBOD    (Move BODy)'
      write(*,*)'    This option allows you to move all points in a'
      write(*,*)'   specified body a specified X and Z distance.'
      return
36    write(*,*)'DBOD    (Delete BODy)'
      write(*,*)'    This option allows you to completely remove a'
      write(*,*)'   specified body.'
      return
37    write(*,*)'ASCA    (Automatic SCAling)'
      write(*,*)'    This option allows automatic scaling of the '
      write(*,*)'   anomalies for plotting.'
      return
38    write(*,*)'CONF    (program CONFiguration)'
      write(*,*)'    This option allows you to set the number of '
      write(*,*)'   steps saved in the recover file and the digitizer'
      write(*,*)'   response delay factor.'
      return
39    write(*,*)'SAVE    (SAVE colour display)'
      write(*,*)'     This option saves the colour screen display'
      write(*,*)'    in a Halo "*.pic" file format with an matching'
      write(*,*)'    Halo "*.pal" palette file.'
      return    
      end
c
c *******************************************************
      SUBROUTINE WRITMOD (IERROR)
c
c Purpose : To write model data to L.U.N. "lunmod"
c
      character string*60, str10*10
c
$include:'magrav.cmn'
c
      ierror = 0
      rewind(lunmod)
c
      string= '! MAGRAV2, ver. 2.0 model file'
      write(lunmod,'(a)') string
      string= '! ----------------------------'
      write(lunmod,'(a)') string
      string='! (Note:lines with "!" as the first character are '
      write(lunmod,'(a)') string
      string='!    ignored when read, so comments may be added'

      write(lunmod,'(a)') string
      string='!    between fields)'
      write(lunmod,'(a)') string
c
c Write "kommnt" string
c
      write(lunmod,'(a)') kommnt
c
c Write observed gravity data
c
      string= '! Observed gravity data'
      write(lunmod,'(a)') string
      string= '!   no. observed points, spacing, "x" offset'
      write(lunmod,'(a)') string
      string= '!   ----------------------------------------'
      write(lunmod,'(a)') string
c
      write(lunmod,*) nfield(1)
      if (nfield(1).eq.0) go to 10
      write(lunmod,*) space(1)
      write(lunmod,*) xoffs(1)
      string = '! observed gravity data'
      write(lunmod,'(a)') string
      write(lunmod,'(f15.5)') (obs(1,k),k=1,nfield(1))
c
c Write observed magnetic data
c
10    string = '! Observed magnetic data'
      write(lunmod,'(a)') string
      string= '!  No. observed points, spacing, "x" offset'
      write(lunmod,'(a)') string
      string= '!  ----------------------------------------'
      write(lunmod,'(a)') string
c
      write(lunmod,*) nfield(2)
      if (nfield(2).eq.0) go to 15
      write(lunmod,*) space(2)
      write(lunmod,*) xoffs(2)
      string = '! observed magnetic data'
      write(lunmod,'(a)') string
      write(lunmod,'(f15.5)') (obs(2,k),k=1,nfield(2))
c
c Write magnetic field parameters
c
      string= '! Magnetic field parameters, xton, dec, dip'
      write(lunmod,'(a)') string
      string= '! -----------------------------------------'
      write(lunmod,'(a)') string
c
      write(lunmod,*) xton
      write(lunmod,*) dec
      write(lunmod,*) dip
c
c Write display parameters
c
15    string= '! Display parameters, zmax'
      write(lunmod,'(a)') string
      string= '! ------------------------'
      write(lunmod,'(a)') string
      write(lunmod,*) zmax
c
      string= '! Display parameters, grav. offset'
      write(lunmod,'(a)') string
      string= '! --------------------------------'
      write(lunmod,'(a)') string
      write(lunmod,*) offset(1)
c
      string= '! Display parameters, mag. offset'
      write(lunmod,'(a)') string
      string= '! -------------------------------'
      write(lunmod,'(a)') string
      write(lunmod,*) offset(2)
c
c Write body data
c ---------------
20    do 100, ibod=1, maxbod
        if(npts(ibod).gt.0) then
          str10= '! Body : '
          write(lunmod,1000) str10,ibod
1000      format(a,i5)
          string= '! -------------'
          write(lunmod,'(a)') string
          string= '! body no., npts, ((x(j),z(j),j=1,npts)'
          write(lunmod,'(a)') string
          write(lunmod,*) ibod
          write(lunmod,*) npts(ibod)
          write(lunmod,'(2f15.5)')
     +          (x(ipt,ibod),z(ipt,ibod),ipt=1,npts(ibod))
c
          string= '!  half strike length, declination, dip'
          write(lunmod,'(a)') string
          write(lunmod,*) bdy(ibod)        
          write(lunmod,*) bdec(ibod)        
          write(lunmod,*) bdip(ibod)        
c
          string= '!  min., actual, max. density'
          write(lunmod,'(a)') string
          write(lunmod,*) rmmin(ibod,1),rhomag(ibod,1),rmmax(ibod,1)        
          string= '!  min., actual, max. magnetization'
          write(lunmod,'(a)') string
          write(lunmod,*) rmmin(ibod,2),rhomag(ibod,2),rmmax(ibod,2)        
        endif
100   continue
c
      write(lunmod,'(a)') '! End of model file' 
      endfile (lunmod)
      write(*,*) ' '
      write(*,*) ' Model file written'
c
      return
      end
c
c *******************************************************
      SUBROUTINE READMOD (IERROR)
c
c Purpose : To read model data in L.U.N. lunmod
c
      character cdum*1, cline*60, str5*5, str15*15
c
$include:'magrav.cmn'
c
      itype = 0
      ierror = 0
      rewind(lunmod)
c
      read(lunmod,'(a)',end=900,err=990) cdum
      cline = 'header 2'
      read(lunmod,'(a)',end=900,err=990) cdum
c
c Read "kommnt" string
c
      cline = 'comment'
      call skipcom(lunmod,kerr)

      if(kerr.eq.1) go to 900 
      read(lunmod,'(a)',end=900,err=990) kommnt
c
c Read observed gravity data
c
      cline = 'no. obs. gravity'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) nfield(1)
      if (nfield(1).eq.0) go to 10
      itype = 1
      if (nfield(1).gt.maxobs) then
        call error('no. of observed gravity data exceeds maximum')
        go to 999
      endif
c
      cline = 'obs. gravity spacing'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) space(1)
c
      cline = 'observed gravity offset'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) xoffs(1)
c
      cline = 'observed gravity data'
      do 5 ig=1, nfield(1)
        call skipcom(lunmod,kerr)
        if(kerr.eq.1) go to 900 
        read(lunmod,*,end=900,err=990) obs(1,ig)
5     continue
      write(*,*) ' '
      write(*,*) 'Observed gravity data read'
c
c Determine start and end points of observed gravity data
c
      ktype = 1
      call obslim(ktype)
c
c Read observed magnetic data
c
10    cline = 'no. obs. mag.'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) nfield(2)
      if (nfield(2).eq.0) go to 20
      if(itype.eq.0) itype = 2
      if (nfield(2).gt.maxobs) then
        call error('no. of observed magnetic data exceeds maximum')
        go to 999
      endif
c
      cline = 'mag. spacing'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) space(2)
c
      cline = 'mag. offset'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) xoffs(2)
c
      cline = 'mag. data'
      do 15 im=1, nfield(2)
        call skipcom(lunmod,kerr)
        if(kerr.eq.1) go to 900 
        read(lunmod,*,end=900,err=990) obs(2,im)
15    continue
      write(*,*) ' '
      write(*,*) 'Observed magnetic data read'
c
c Determine start and end points of observed magnetic data
c
      ktype = 2
      call obslim (ktype)
c
c Read magnetic field parameters
c
19    cline = 'mag. "xton"'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) xton
c
      cline = 'mag. declination'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) dec
c
      cline = 'mag. dip'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) dip
c
c Read plotting parameters
c
20    cline = 'plot param.: zmax"'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) zmax
c
      cline = 'plot param.: grav. offset"'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) offset(1)
c
      cline = 'plot param.: mag. offset"'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) offset(2)
c
c Read body data
c ---------------
      nbods = 0
      str15 = 'plot par.'
c
100   cline = 'body after '//str15
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 800 
      read(lunmod,*,end=900,err=990) ibod
c
      if (ibod.gt.maxbod) then
        call error('no. of bodies exceeds maximum allowed')
        go to 999
      endif
      write(str5,'(i5)') ibod
      write(*,*)'Body',ibod,' read'
      str15 = ' Body '//str5 
c
      cline = 'no. points'//str15
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) npts(ibod)
c
      if (npts(ibod).gt.(maxnpt+1)) then
        call error('no. of body points exceeds maximum allowed')
        go to 999
      endif
c
c Initialize all body points positions to (0,0)
c
      do 150 kount = 1, maxnpt
        x(kount,ibod) = 0.
        z(kount,ibod) = 0.
150   continue
c
      cline = 'X+Z '//str15
c
      do 200 kp=1, npts(ibod)
        call skipcom(lunmod,kerr)
        if(kerr.eq.1) go to 900 
        read(lunmod,*,end=900,err=990) x(kp,ibod),z(kp,ibod)
200   continue
c
      cline = 'half strike length '//str15
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) bdy(ibod)        
c
      cline = str15//' declination'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) bdec(ibod)        
c
      cline = str15//' dip'
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990) bdip(ibod)        
c
      cline = 'density param. '//str15
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990)
     +    rmmin(ibod,1),rhomag(ibod,1),rmmax(ibod,1)        
c
      cline = 'mag. param. '//str15 
      call skipcom(lunmod,kerr)
      if(kerr.eq.1) go to 900 
      read(lunmod,*,end=900,err=990)
     +    rmmin(ibod,2),rhomag(ibod,2),rmmax(ibod,2)        
      ianom(ibod) = 1
      nbods = nbods + 1
c
c   Check if body is closed, if not, close it
c
      if(x(1,ibod).ne.x(npts(ibod),ibod).or.
     +     z(1,ibod).ne.z(npts(ibod),ibod))then
        if(npts(ibod).eq.maxnpt) npts(ibod) = npts(ibod) - 1
        npts(ibod) = npts(ibod) + 1
        ianom(ibod) = 0
        x(npts(ibod),ibod) = x(1,ibod)
        z(npts(ibod),ibod) = z(1,ibod)
        write(*, *) 'Body :', ibod, ' closed'
      endif
c
c  Check for duplicate consecutive points,
c   if found, delete them.
c
      call remdup (ibod)
      go to 100
c 
c If a body number is undefined, Reset all body co-ords to (0,0)
c
800   do 810 ibod = 1, maxbod
        if (npts(ibod).le.0) then
          ianom(ibod) = 0
          do 820 j=1 , maxnpt + 1
            x(j,ibod) = 0.0
            z(j,ibod) = 0.0
820       continue
        endif
810   continue
c
      call rean
      kalk = 1
c
      write(*,*) ' '
      write(*,*) 'MODEL SUMMARY'
      write(*,*) '-------------'
      write(*,'(a,i5)') ' Number of gravity profile points: ',nfield(1)
      write(*,'(a,i5)') ' Number of magnetic profile points: ',nfield(2)
      write(*,'(a,i5)') ' Number of bodies: ',nbods
      write(*,*) kommnt
      go to 999
c
900   call error('Unexpected E.O.F reading models file')
      go to 999
c
990   call error('Reading models file')
      write(*,*)' failed reading:',cline
c      call hret
c      
999   kalk = 1
      itypeo = -99
      return
      end
c
c **********************************************************
      SUBROUTINE OBSLIM(KTYPE)
c
c Purpose : To determine the start and end points of the 
c           observed data ostart(itype), and oend(itype) to 
c           allow boundary values (-9999.0) in the observed data. 
c
$include:'magrav.cmn'
c
c Locate start observed profile point by skipping
c  "-9999.0" values
c
      do 10 ig=1, nfield(ktype)
        if (obs(ktype,ig).ne.-9999.0) then
          ostart(ktype) = ig
          go to 20
        endif
10    continue
c
c Locate end observed profile point by locating
c  first trailing "-9999.0" value
c
20    do 30 ig=ostart(ktype), nfield(ktype)
        if (obs(ktype,ig).eq.-9999.0) then
          oend(ktype) = ig-1
          go to 999
        else
          if(ig.eq.nfield(ktype)) oend(ktype) = nfield(ktype)
        endif
30    continue
c
999   return
      end
c
c *******************************************************
      SUBROUTINE SKIPCOM(LUN,IERR)
c
c Purpose : To read past lines in an ASCII file starting
c           with a "!".  When a non-comment line is found the 
c           subroutine returns to the main progran positioned 
c           at the start of that line.
c
      character buff*135
      integer*2 lun
c
      ierr = 0
10    read(lun,'(a)',end=900) buff
      if(buff(1:1).eq.'!') then
        go to 10
      else
        backspace(lun)
        go to 999
      endif
c
900   ierr = 1
999   return
      end
