c
c MAGRAV2 (v. 2.1 )  SUBROUTINE BLOCK : MS7, Halo Professional
c Edited : Aug. 19 , 1992, J. Broome
c Subroutine DIGIT set for Kurta/Bit Pad One digitizer
c
$nofloatcalls
c
c **************************************************************
c
      SUBROUTINE CHKERR
c
c purpose : To check "halo" error status and print out
c           the function producing the error and the error
c           type.
c
c parameters : ifun - "halo" function where error occurred
c              ierr - error type(see "halo" manual)
c
$include:'magrav.cmn'
c
      call inqerr (ifun,ierr)
      if(ierr.ne.0) then
        call error('  ')
        write(*,1111) sgr1
        write(*,*)'Error number:',ierr,', in Halo function : ',ifun
        write(*,1111) sgr0
      endif
      return
      end
c
c
c ***************************************************************
      SUBROUTINE DELAY(N)
c
c Purpose : to add a delay to the program to eliminate
c     duplicate point entry from the graphics pad
c
$include:'magrav.cmn'
c
      loop = idelay * n
      do 10 j = 1 , loop
        k= j
 10   continue
c
      return
      end
c
c ****************************************************************
      SUBROUTINE IDBODY (IBOD)
c
c purpose : To allow bodies to be identified using the cursor 
c           on the digitizer pad.
c
c Parameters : ibod - body point is found in
c                     "-1" if point not defined
c             
$include:'magrav.cmn'
c
      call sound(10,1000)
      call inidis(2,nclr)
      call curpos (0)
      call check(1,xc,zc,iduppt,idupbd,iret)
      call delay(10)
      do 10 kbod = 1 , maxbod
        if(npts(kbod).eq.0) go to 10
        xp = xc
        zp = zc
        call polyin(xp,zp,kbod,istat)
        if(istat.eq.1) then
          ibod = kbod
          go to 20
        endif
10    continue
c
      call error (' Point not found in any body')
      ibod = -1
c
20    call delhcu
      return
      end
c
c **************************************************************
      SUBROUTINE MSCALE
c
c purpose : To allow manual setting of plot scaling parameters
c
$include:'magrav.cmn'
c
      write(*,*)'Current DRAW crosssection depth :',zmax
      write(*,'(a\)')' Enter new DRAW crossection depth : '
      call sound(20,200)
      read(*,*,err=400) zmax
      zlpl = zmax
      zupl = 0.0
      write(*,*) ' '
      write(*,*)'Current profile plot minimum :',anomin(itype)
      write(*,'(a\)')' Enter new profile plot minimum : '
      call sound(20,200)
      read(*,*,err=400) anomin(itype)
      write(*,*) ' '
      write(*,*)'Current profile plot maximum :',anomax(itype)
      write(*,'(a\)')' Enter new profile plot maximum : '
      call sound(20,200)
      read(*,*,err=400) anomax(itype)
      if(anomax(itype).le.anomin(itype)) then
        call error('Anomaly plot minimum is larger then maximum')
        return
      endif
      write(*,*) ' '
      write(*,*)'Current SKETCH crossection depth(km) : ',zlpl
      write(*,'(a\)')' Enter new SKETCH crossection depth : '
      call sound(20,200)
      read(*,*,err=400) skzmax
      write(*,*) ' '
      write(*,'(a\)')' Modify the X SKETCH limits (y/n) : '
      call sound(20,200)
      read(*,'(a)',err=400) ans
      if(ans.eq.'y'.or.ans.eq.'Y') then
        write(*,1000) skxmin,skxmax
1000    format(1h ,'Current X min and max = ',2f9.2)
        write(*,'(a\)')' Enter new SKETCH X min. : '
        call sound(20,200)
        read(*,*,err=400) skxmin
        write(*,'(a\)')' Enter new SKETCH X max. : '
        call sound(20,200)
        read(*,*,err=400) skxmax
      endif
      return
c
400   call error ('Input error')
      return
      end
c
c **********************************************************
      SUBROUTINE POLYIN(XP,YP,IBOD,ISTAT)
c
c Purpose : To determine if point (XP,YP) is within body (IBOD)
c        ISTAT returns whether point (XP,YP) is inside body
c        IBOD (ISTAT=1) or outside (ISTAT=0).
c
$include:'magrav.cmn'
c
      istat = 0
      x1 = x(1,ibod)
      y1 = z(1,ibod)
c
      do 50 i = 2 , npts(ibod)
        x2 = x(i,ibod)
        y2 = z(i,ibod)
        if(xp.eq.x2.and.yp.eq.y2) go to 55
        ymin = amin1(y1,y2)
        ymax = amax1(y1,y2)
        yc = ymax-ymin
        if(yc.eq.0.0.and.yp.eq.ymax) then
          a = amin1(x1,x2)
          b = amax1(x1,x2)
          if (xp.lt.a.or.xp.gt.b) go to 40
          go to 55
        endif
        if (yp.lt.ymin.or.yp.ge.ymax) go to 40
c
        b = x1-x2
        if (b.eq.0.0) then
          if (x1.eq.xp) go to 55
          if (x1.lt.xp) istat = istat + 1
          go to 40
        endif
        a = (y1-y2)/b
        b = y1 - a*x1
        yc = a*xp + b
        if (yp.eq.yc) go to 55
        if (yp.lt.yc.and.a.gt.0.0) istat = istat + 1
        if (yp.gt.yc.and.a.lt.0.0) istat = istat + 1
        go to 40
c
40      x1 = x2
        y1 = y2
50    continue
c
      istat = mod(istat,2)
      go to 999
c
55    istat = 1
c
999   return
      end
c
c ********************************************************
      SUBROUTINE IDPOIN (MBOD,MPT,N,IRL)
c 
c Purpose : To identify points and the body they are in.
c
c Arguments : mbod - array of bodies the point is in
c             mpt  - array of point numbers for each
c                     body
c             n - input : 1 - ask user to select body
c                         0 - don't ask user to select body
c               - output : number of points returned
c                          (-1 for no points returned)
c
c            irl - irl=1 for rubberband line in curpos
c
      integer*2 mbod(15),mpt(15)
$include:'magrav.cmn'
c
      call sound(10,1000)
      call curpos (irl)
      call delay (10)
      nn = 1
      do 10 j=1, 10
        call check(nn,xc,zc,ibod,npt,iret)
        if(iret.eq.0) then
          mbod(nn) = ibod
          mpt(nn)  = npt
          nn = nn + 1
        else
          if(nn.eq.1) then
            write(*,*)' '
            call error (' Point not found in any body.')
            n = -1
            go to 999
          endif
        endif
10    continue
c
      nn = nn - 1
      if(nn.eq.1) then
        n = 1
        go to 999
      endif
c
20    if (n.eq.0) then
        n = nn
        go to 999
      endif
      write(*,*)' '
      write(*,*)'The point is found in  bodies : '
      write(*,*)' '
      write(*,1000)(mbod(j),colour(mbod(j)),j=1,nn)
1000  format(i5,' (',a10,')')
      call sound(20,200)
      write(*,1010)
1010  format(/,' Select the body to be acted on("0" for',
     +' all) : ',\)
      read(*,*,err=400) lbod
      if(lbod.eq.0) then
        n = nn
        go to 999
      endif
30    do 50 j = 1 , nn
         if(mbod(j).eq.lbod) then
            mbod(1) = lbod
            mpt(1) = mpt(j)
            n = 1
            go to 999
         endif
50    continue
c
      write(*,*)' '
      call error(' Point was not found in the body selected')
      go to 20
c
400   call error (' Input error!')
      go to 20
c
999   call delhcu
      return
      end
c
c ****************************************************************
      SUBROUTINE SEGMNT (IERR)
c
c Purpose : to identify a portion of the profile segment
c           Start and end profile points are placed stored in
c           variables "imoves" and "imovee".
c
c Parameters : IERR - set to 1 for error in subroutine
c
$include:'magrav.cmn'
c
      write(*,*)' '
      write(*,*)'Use cursor to select left endpoint of profile'
      write(*,*)' segment to be fitted.'
      dx = (xupl-xlpl)/10000.0
      call inidis (1,nclr)
      call setcol (iwht)
      call delay (100)
c
100   call digit
      xcs = jx*dx + xlpl
      call movabs (xcs, anomin(itype))
      call rlnabs (xcs,anomax(itype))
      if(jf.ne.4) go to 100
c
      call sound(10,70)
      kflag = 0
      write(*,*)' '
      write(*,*)'Use cursor to select right endpoint of profile'
      write(*,*)' segment to be fitted.'
      call delay (100)
200   call digit
      xce = jx*dx + xlpl
      if(xce.lt.xcs) then
        if(kflag.eq.0) then
          call error('Select point to the right of previous point')
          kflag = 1
        endif
        go to 200
      endif
      call delln
      call rbox(xcs, anomin(itype), xce, anomax(itype))
      if( jf.ne.4) go to 200
c
c Convert x coordinates of profile segment endpoints to point numbers
c
      imoves = -1
      imovee = -1
c
      do 300 j = 1 , nfield(itype) - 1
        if(xcs.lt.xpos(j+1,itype)) then
          imoves = j
          go to 400
        endif
300   continue
c
400   do 500 j = 1 , nfield(itype) - 1
        if(xce.lt.xpos(j+1,itype)) then
          imovee = j
          go to 600
        endif
500   continue
c
600   if(imoves.eq.-1.or.imovee.eq.-1) then
        call error('Start or endpoint not determined, retry')
        call delbox
        ierr = 1
      endif
c
      return
      end
c
c *****************************************************************
      SUBROUTINE HRET
c
c Purpose: This routine tells user to hit a key to continue
c
      character*1 dum
      integer     iocheck
c
      write (*,10)
10    format (/, 1x, 'Hit ENTER to continue. ', \)
      read (*, '(a)', iostat=iocheck) dum
c
      end
c
c ******************************************************
      SUBROUTINE SETPRT
c
c Purpose : To initialize Halo printers.  Current options
c           include a) HP laserjet II
c                   b) Tectronix 4696
c                   c) Postscript
c
      character*40 prndrv
      integer*2 pattr(64)
c
$include:'magrav.cmn'
c
      if (iprnt.eq.0) then
        write(*,*) ' '
        write(*,*) 'No printer selected, select option "CONF"'
c
c HP Laserjet II
c --------------
      elseif (iprnt.eq.1) then
        call setprn('//')
        prndrv = '/c:\hpro\dev\drivers\AHDLJTP.PRT/'
        call setprn (prndrv)
        call chkerr
c
c Initialize attribute table to select defaults
c
        do 10 j=1, 64
          pattr(j) = -1
10      continue
c
c Change printer defaults where required
c --------------------------------------
c set image width: 3000
        pattr (1) = 3000
c
c Set image height : 2250
        pattr (2) = 2250
c
c Orientation: landscape 
        pattr (3) = 1
c
        call setpat (pattr)
        call chkerr
c
        write(*,*)' '
        write(*,*)'HP Laserjet Printer initialized on LPT1'
        write(*,*)'(300 DPI, landscape mode)'
c
c Tektronix 4696
c --------------
      elseif (iprnt.eq.2) then
        call setprn('//')
        prndrv = '/c:\hpro\dev\drivers\AHDTK96.PRT/'
        call setprn (prndrv)
        call chkerr
c
c Initialize attribute table to select defaults
c
        do 110 j=1, 64
          pattr(j) = -1
110     continue
c
c Change printer defaults where required
c --------------------------------------
c set image width: 1200
        pattr (1) = 1200
c
c Set image height : 1000
        pattr (2) = 1000
c
c Orientation: landscape 
        pattr (3) = 1
c
        call setpat (pattr)
        call chkerr
c
        write(*,*)' '
        write(*,*)'Tektronix 4696 Printer initialized on LPT1'
        write(*,*)'(120 DPI, landscape mode)'
c
c Postscript B+W
c --------------
      elseif (iprnt.eq.3) then
        call setprn('//')
        prndrv = '/c:\hpro\dev\drivers\AHDPSCT.PRT/'
        call setprn (prndrv)
        call chkerr
c
c Initialize attribute table to select defaults
c
        do 210 j=1, 64
          pattr(j) = -1
210     continue
c
c Change printer defaults where required
c --------------------------------------
c set image width: 2900
        pattr (1) = 2900
c
c Set image height : 2100
        pattr (2) = 2100
c
c Orientation: landscape 
        pattr (3) = 1
c
        call setpat (pattr)
        call chkerr
c
        write(*,*)' '
        write(*,*)'Postscript B+W Printer initialized on LPT1'
        write(*,*)'(300 DPI, landscape mode)'
      endif
c
999   return
      end
c
c *********************************************************
      SUBROUTINE PRNT
c
c Purpose : To print the current screen image
c
      character*40 ans
      integer*2 inten
c
$include:'magrav.cmn'
c
      write(*,'(/a\)')' Use grey palette for printing?(y/n)[y]: '
      read(*,'(a)') ans
c
c Change colours file names, read, and initialize new colours
c
      if (ans.ne.'n'.and.ans.ne.'N') then
        ccolvga = 'magvgag.col'
        ccolnec = 'magnecg.col'
        call readcol (ierr)
        if (ierr.ne.0) call error('reading "grey" colours files')
        call initcol
      endif
c
c Modify colour "igry" to clarify banner
c
      igry  = 63
      inten = 220
      call setcpa (igry,inten,inten,inten)
c
c
      write(*,*) ' '
      write(*,*)'Sending image to printer, please be patient ...'
c
c Inquire current viewport, save for restoration on exit
c
      call inqvie(x1, y1, x2, y2)
      call chkerr
      call setvie (0.0, 0.0, 1.0, 1.0, -1, -1)
      call chkerr
c
      call gprint
      call chkerr
c
      write(*,*) ' image print completed'
c
c Restore viewport and colours
c
      call setvie (x1, y1, x2, y2, -1, -1)
      ccolvga = 'magvga.col'
      ccolnec = 'magnec.col'
      call readcol (ierr)
      if (ierr.ne.0) call error('reading colours files')
      call initcol 
c
      return
      end
c
c **********************************************************
      SUBROUTINE READCOL (IERR)
c
c Purpose : To open and read colours from a *.COL files
c           and store them in an array.  
c
c Arguments : ierr  = set to 1 on error in subroutine
c
      character cdum*75, cpre*3, ctemp*10, filb*40
      character tcolor*10
c
$include:'magrav.cmn'
c
c Set file name based on graphics board type
c
      if (igrap.eq.1) then
        filb = ccolvga
      elseif (igrap.eq.2) then
        filb = ccolnec
      endif
c
c Read colours and store in array
c ------------------------------------
      open(luncol,file=filb,status='old',form='formatted',err=99)
      rewind (luncol)
c
c Skip descriptive header 
c 
      read(luncol,'(a)',err=199) cdum
      ipal = 1
c
      do 10 n = 1,24
        if(igrap.eq.1) then
          read(luncol,1000,end=15,err=199) j, icolr(n), tcolor
1000      format(2i5,1x,a)
          if(j.gt.0.and.j.lt.15) colour(j) = tcolor
c          write(*,*)'READCOL:n,bodycol:',n,icolr(n)
        elseif(igrap.eq.2) then
          read(luncol,1010,end=15,err=199) j, ired(n), igrn(n),
     +     iblu(n), tcolor
1010      format(4i5,1x,a)
          if(j.gt.0.and.j.lt.15) colour(j) = tcolor
c          write(*,*)'j,colour(j)=',j,colour(j)
          ncolor = n
        endif
10    continue
c 
15    if (igrap.eq.1) ncolor = 14
c
c Set descriptive strings for body colours 14-26
c  Note: the first 13 colours are always body colours
c
30    cpre = 'st.'
      do 50 n = 14, 26
        ctemp = colour(n-13)
        ctemp(:3)  = cpre
        colour(n) = ctemp
50    continue
c
      go to 999
c
99    call error('opening  "*.col"')
      ierr = 1
      call hret
      go to 999
c
199   call error('reading "*.col"')
      ierr = 1
      call hret
      go to 999
c
999   return
      end
c
c ***********************************************************
      SUBROUTINE INITCOL
c
c Purpose : to initialize Halo colours
c
      integer*2 n,inten,jcol
c
$include:'magrav.cmn'
c
c For VGA graphics
c ----------------
      if(igrap.eq.1) then
        do 10 n = 1, ncolor
          call setxpa(n,icolr(n))
c          write(*,*)'INITCOL:n,icolr=',n,icolr(n)
10      continue
c
c Note: for VGA colour 0 always =0; and colour 15 always= 63
c
        iblk  = 0
        inten = 0
        call setxpa(iblk,inten)
        iwht  = 15
        inten = 63
        call setxpa(iwht,inten)
        igry  = 14
        igry2 = iwht
        iobsc = iwht
        nclr  = -1
c
c For NEC-MGE
c -----------------------------------------
      elseif(igrap.eq.2) then
        do 20 n = 1, ncolor
          call setcpa(n,ired(n),igrn(n),iblu(n))
c         write(*,*)'INITCOL:',n,ired(n),igrn(n),iblu(n)
c
c Colours 1 to 20 are duplicated as colours 41 to 60 to allow
c   a line overlay on background images in correct body colours
c   while the image overlay is enables. (NEC-MGE only)
c
          if(n.le.20) then
            jcol = n + 40
            call setcpa(jcol,ired(n),igrn(n),iblu(n))
          endif
20      continue
c
c Colours :  "0" always       black = (0,0,0); iblk
c           "255" always      white = (255,255,255); iwht
c           "63" always dark gray  = (40,40,40); igry
c           "62" always light gray   = (160,160,160); igry2
c           "64" always bright red   = (255,0,0); observed colour
c
        iblk  = 0
        inten = 0
        call setcpa(iblk,inten,inten,inten)
        iwht  = 255
        inten = 255
        call setcpa(iwht,inten,inten,inten)
        igry  = 63
        inten = 40
        call setcpa (igry,inten,inten,inten)
        igry2  = 62
        inten = 160
        call setcpa (igry2,inten,inten,inten)
        iobsc  = 64
        inten = 255
        n = 0
        call setcpa (iobsc,inten,n,n)
        nclr  = -1
      endif
      return
      end
